﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.IntegerVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Operators {
  [Item("GQAPPathRelinking", "Operator that performs path relinking between two solutions.")]
  [StorableClass]
  public class GQAPPathRelinking : GQAPCrossover {

    [StorableConstructor]
    protected GQAPPathRelinking(bool deserializing) : base(deserializing) { }
    protected GQAPPathRelinking(GQAPPathRelinking original, Cloner cloner) : base(original, cloner) { }
    public GQAPPathRelinking()
      : base() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new GQAPPathRelinking(this, cloner);
    }

    protected override IntegerVector Cross(IRandom random, ItemArray<IntegerVector> parents) {
      throw new NotImplementedException();
    }
  }
}
